VSphereVM [infrastructure.cluster.x-k8s.io/v1beta1]

VSphereVM 是底层 provider 资源,用于表示在 vCenter 中、为 VSphereMachine 提供支撑的虚拟机。它由 provider controller 创建,而不是由最终用户创建。运维人员在排查克隆、IP 分配或电源状态问题时,会直接检查它。

Description
VSphereVM is the Schema for the vspherevms API Deprecated: This type will be removed in one of the next releases.
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

VSphereVMSpec defines the desired state of VSphereVM.

statusobject

VSphereVMStatus defines the observed state of VSphereVM

.spec

Description
VSphereVMSpec defines the desired state of VSphereVM.
Type
object
Required
networktemplate
PropertyTypeDescription
biosUUIDstring

BiosUUID is the VM's BIOS UUID that is assigned at runtime after the VM has been created. This field is required at runtime for other controllers that read this CRD as unstructured data.

bootstrapRefobject

BootstrapRef is a reference to a bootstrap provider-specific resource that holds configuration details. This field is optional in case no bootstrap data is required to create a VM.

cloneModestring

CloneMode specifies the type of clone operation. The LinkedClone mode is only supported for templates that have at least one snapshot. If the template has no snapshots, then CloneMode defaults to FullClone. When LinkedClone mode is enabled the DiskGiB field is ignored as it is not possible to expand disks of linked clones. Defaults to LinkedClone, but fails gracefully to FullClone if the source of the clone operation has no snapshots.

customVMXKeysobject

CustomVMXKeys is a dictionary of advanced VMX options that can be set on VM Defaults to empty map

datacenterstring

Datacenter is the name or inventory path of the datacenter in which the virtual machine is created/located.

datastorestring

Datastore is the name or inventory path of the datastore in which the virtual machine is created/located.

diskGiBinteger

DiskGiB is the size of a virtual machine's disk, in GiB. Defaults to the eponymous property value in the template from which the virtual machine is cloned.

folderstring

Folder is the name or inventory path of the folder in which the virtual machine is created/located.

memoryMiBinteger

MemoryMiB is the size of a virtual machine's memory, in MiB. Defaults to the eponymous property value in the template from which the virtual machine is cloned.

networkobject

Network is the network configuration for this machine's VM.

numCPUsinteger

NumCPUs is the number of virtual processors in a virtual machine. Defaults to the eponymous property value in the template from which the virtual machine is cloned.

numCoresPerSocketinteger

NumCoresPerSocket is the number of cores per socket in a virtual machine. Defaults to the eponymous property value in the template from which the virtual machine is cloned.

resourcePoolstring

ResourcePool is the name or inventory path of the resource pool in which the virtual machine is created/located.

serverstring

Server is the IP address or FQDN of the vSphere server on which the virtual machine is created/located.

snapshotstring

Snapshot is the name of the snapshot from which to create a linked clone. This field is ignored if LinkedClone is not enabled. Defaults to the source's current snapshot.

storagePolicyNamestring

StoragePolicyName of the storage policy to use with this Virtual Machine

templatestring

Template is the name or inventory path of the template used to clone the virtual machine.

thumbprintstring

Thumbprint is the colon-separated SHA-1 checksum of the given vCenter server's host certificate When this is set to empty, this VirtualMachine would be created without TLS certificate validation of the communication between Cluster API Provider vSphere and the VMware vCenter server.

.spec.bootstrapRef

Description
BootstrapRef is a reference to a bootstrap provider-specific resource that holds configuration details. This field is optional in case no bootstrap data is required to create a VM.
Type
object
PropertyTypeDescription
apiVersionstring

API version of the referent.

fieldPathstring

If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: "spec.containers{name}" (where "name" refers to the name of the container that triggered the event) or if no container name is specified "spec.containers[2]" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.

kindstring

Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

namestring

Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

namespacestring

Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/

resourceVersionstring

Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

uidstring

UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids

.spec.customVMXKeys

Description
CustomVMXKeys is a dictionary of advanced VMX options that can be set on VM Defaults to empty map
Type
object

.spec.network

Description
Network is the network configuration for this machine's VM.
Type
object
Required
devices
PropertyTypeDescription
devicesarray

Devices is the list of network devices used by the virtual machine.

preferredAPIServerCidrstring

PreferredAPIServeCIDR is the preferred CIDR for the Kubernetes API server endpoint on this machine

routesarray

Routes is a list of optional, static routes applied to the virtual machine.

.spec.network.devices

Description
Devices is the list of network devices used by the virtual machine.
Type
array

.spec.network.devices[]

Description
NetworkDeviceSpec defines the network configuration for a virtual machine's network device.
Type
object
Required
networkName
PropertyTypeDescription
deviceNamestring

DeviceName may be used to explicitly assign a name to the network device as it exists in the guest operating system.

dhcp4boolean

DHCP4 is a flag that indicates whether or not to use DHCP for IPv4 on this device. If true then IPAddrs should not contain any IPv4 addresses.

dhcp6boolean

DHCP6 is a flag that indicates whether or not to use DHCP for IPv6 on this device. If true then IPAddrs should not contain any IPv6 addresses.

gateway4string

Gateway4 is the IPv4 gateway used by this device. Required when DHCP4 is false.

gateway6string

Gateway6 is the IPv6 gateway used by this device. Required when DHCP6 is false.

ipAddrsarray

IPAddrs is a list of one or more IPv4 and/or IPv6 addresses to assign to this device. IP addresses must also specify the segment length in CIDR notation. Required when DHCP4 and DHCP6 are both false.

macAddrstring

MACAddr is the MAC address used by this device. It is generally a good idea to omit this field and allow a MAC address to be generated. Please note that this value must use the VMware OUI to work with the in-tree vSphere cloud provider.

mtuinteger

MTU is the device’s Maximum Transmission Unit size in bytes.

nameserversarray

Nameservers is a list of IPv4 and/or IPv6 addresses used as DNS nameservers. Please note that Linux allows only three nameservers (https://linux.die.net/man/5/resolv.conf).

networkNamestring

NetworkName is the name of the vSphere network to which the device will be connected.

routesarray

Routes is a list of optional, static routes applied to the device.

searchDomainsarray

SearchDomains is a list of search domains used when resolving IP addresses with DNS.

.spec.network.devices[].ipAddrs

Description
IPAddrs is a list of one or more IPv4 and/or IPv6 addresses to assign to this device. IP addresses must also specify the segment length in CIDR notation. Required when DHCP4 and DHCP6 are both false.
Type
array

.spec.network.devices[].ipAddrs[]

Type
string

.spec.network.devices[].nameservers

Description
Nameservers is a list of IPv4 and/or IPv6 addresses used as DNS nameservers. Please note that Linux allows only three nameservers (https://linux.die.net/man/5/resolv.conf).
Type
array

.spec.network.devices[].nameservers[]

Type
string

.spec.network.devices[].routes

Description
Routes is a list of optional, static routes applied to the device.
Type
array

.spec.network.devices[].routes[]

Description
NetworkRouteSpec defines a static network route.
Type
object
Required
metrictovia
PropertyTypeDescription
metricinteger

Metric is the weight/priority of the route.

tostring

To is an IPv4 or IPv6 address.

viastring

Via is an IPv4 or IPv6 address.

.spec.network.devices[].searchDomains

Description
SearchDomains is a list of search domains used when resolving IP addresses with DNS.
Type
array

.spec.network.devices[].searchDomains[]

Type
string

.spec.network.routes

Description
Routes is a list of optional, static routes applied to the virtual machine.
Type
array

.spec.network.routes[]

Description
NetworkRouteSpec defines a static network route.
Type
object
Required
metrictovia
PropertyTypeDescription
metricinteger

Metric is the weight/priority of the route.

tostring

To is an IPv4 or IPv6 address.

viastring

Via is an IPv4 or IPv6 address.

.status

Description
VSphereVMStatus defines the observed state of VSphereVM
Type
object
PropertyTypeDescription
addressesarray

Addresses is a list of the VM's IP addresses. This field is required at runtime for other controllers that read this CRD as unstructured data.

cloneModestring

CloneMode is the type of clone operation used to clone this VM. Since LinkedClone is the default but fails gracefully if the source of the clone has no snapshots, this field may be used to determine the actual type of clone operation used to create this VM.

conditionsarray

Conditions defines current service state of the VSphereVM.

failureMessagestring

FailureMessage will be set in the event that there is a terminal problem reconciling the vspherevm and will contain a more verbose string suitable for logging and human consumption.

This field should not be set for transitive errors that a controller faces that are expected to be fixed automatically over time (like service outages), but instead indicate that something is fundamentally wrong with the vm.

Any transient errors that occur during the reconciliation of vspherevms can be added as events to the vspherevm object and/or logged in the controller's output.

failureReasonstring

FailureReason will be set in the event that there is a terminal problem reconciling the vspherevm and will contain a succinct value suitable for vm interpretation.

This field should not be set for transitive errors that a controller faces that are expected to be fixed automatically over time (like service outages), but instead indicate that something is fundamentally wrong with the vm.

Any transient errors that occur during the reconciliation of vspherevms can be added as events to the vspherevm object and/or logged in the controller's output.

networkarray

Network returns the network status for each of the machine's configured network interfaces.

readyboolean

Ready is true when the provider resource is ready. This field is required at runtime for other controllers that read this CRD as unstructured data.

retryAfterstring

RetryAfter tracks the time we can retry queueing a task

snapshotstring

Snapshot is the name of the snapshot from which the VM was cloned if LinkedClone is enabled.

taskRefstring

TaskRef is a managed object reference to a Task related to the machine. This value is set automatically at runtime and should not be set or modified by users.

.status.addresses

Description
Addresses is a list of the VM's IP addresses. This field is required at runtime for other controllers that read this CRD as unstructured data.
Type
array

.status.addresses[]

Type
string

.status.conditions

Description
Conditions defines current service state of the VSphereVM.
Type
array

.status.conditions[]

Description
Condition defines an observation of a Cluster API resource operational state.
Type
object
Required
statustype
PropertyTypeDescription
lastTransitionTimestring

Last time the condition transitioned from one status to another. This should be when the underlying condition changed. If that is not known, then using the time when the API field changed is acceptable.

messagestring

A human readable message indicating details about the transition. This field may be empty.

reasonstring

The reason for the condition's last transition in CamelCase. The specific API may choose whether or not this field is considered a guaranteed API. This field may not be empty.

severitystring

Severity provides an explicit classification of Reason code, so the users or machines can immediately understand the current situation and act accordingly. The Severity field MUST be set only when Status=False.

statusstring

Status of the condition, one of True, False, Unknown.

typestring

Type of condition in CamelCase or in foo.example.com/CamelCase. Many .condition.type values are consistent across resources like Available, but because arbitrary conditions can be useful (see .node.status.conditions), the ability to deconflict is important.

.status.network

Description
Network returns the network status for each of the machine's configured network interfaces.
Type
array

.status.network[]

Description
NetworkStatus provides information about one of a VM's networks.
Type
object
Required
macAddr
PropertyTypeDescription
connectedboolean

Connected is a flag that indicates whether this network is currently connected to the VM.

ipAddrsarray

IPAddrs is one or more IP addresses reported by vm-tools.

macAddrstring

MACAddr is the MAC address of the network device.

networkNamestring

NetworkName is the name of the network.

.status.network[].ipAddrs

Description
IPAddrs is one or more IP addresses reported by vm-tools.
Type
array

.status.network[].ipAddrs[]

Type
string

API Endpoints

The following API endpoints are available:

  • /apis/infrastructure.cluster.x-k8s.io/v1alpha3/namespaces/{namespace}/vspherevms
    • DELETE: delete collection of VSphereVM
    • GET: list objects of kind VSphereVM
    • POST: create a new VSphereVM
  • /apis/infrastructure.cluster.x-k8s.io/v1alpha3/namespaces/{namespace}/vspherevms/{name}
    • DELETE: delete the specified VSphereVM
    • GET: read the specified VSphereVM
    • PATCH: partially update the specified VSphereVM
    • PUT: replace the specified VSphereVM
  • /apis/infrastructure.cluster.x-k8s.io/v1alpha3/namespaces/{namespace}/vspherevms/{name}/status
    • GET: read status of the specified VSphereVM
    • PATCH: partially update status of the specified VSphereVM
    • PUT: replace status of the specified VSphereVM

/apis/infrastructure.cluster.x-k8s.io/v1alpha3/namespaces/{namespace}/vspherevms

HTTP method
DELETE
Description
delete collection of VSphereVM
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind VSphereVM
HTTP responses
HTTP codeResponse body
200 - OKVSphereVMList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new VSphereVM
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyVSphereVM schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKVSphereVM schema
201 - CreatedVSphereVM schema
202 - AcceptedVSphereVM schema
401 - UnauthorizedEmpty

/apis/infrastructure.cluster.x-k8s.io/v1alpha3/namespaces/{namespace}/vspherevms/{name}

HTTP method
DELETE
Description
delete the specified VSphereVM
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified VSphereVM
HTTP responses
HTTP codeResponse body
200 - OKVSphereVM schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified VSphereVM
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKVSphereVM schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified VSphereVM
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyVSphereVM schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKVSphereVM schema
201 - CreatedVSphereVM schema
401 - UnauthorizedEmpty

/apis/infrastructure.cluster.x-k8s.io/v1alpha3/namespaces/{namespace}/vspherevms/{name}/status

HTTP method
GET
Description
read status of the specified VSphereVM
HTTP responses
HTTP codeResponse body
200 - OKVSphereVM schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified VSphereVM
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKVSphereVM schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified VSphereVM
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyVSphereVM schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKVSphereVM schema
201 - CreatedVSphereVM schema
401 - UnauthorizedEmpty